<%-- $Id: view_agent.jsp 5509 2010-11-19 10:38:33Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Nicklas Nordborg
	Copyright (C) 2007 Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Job"
	import="net.sf.basedb.core.JobAgent"
	import="net.sf.basedb.core.JobAgentSettings"
	import="net.sf.basedb.util.jobagent.JobAgentInfo"
	import="net.sf.basedb.util.jobagent.JobInfo"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.util.NameablePluginAdaptor"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Map"
	import="java.util.Set"
	import="java.util.Date"
	import="java.util.Collections"
	import="java.util.List"
		
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.JOBAGENT;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	Formatter<Date> dateFormatter = FormatterFactory.getDateTimeFormatter(sc);

	String title = null;
	JobAgent agent = JobAgent.getById(dc, itemId);
	
	JobAgentInfo info = agent.getInfo();
	Boolean paused = info.isPaused();
	
	final boolean writePermission = agent.hasPermission(Permission.WRITE);
	final boolean deletePermission = agent.hasPermission(Permission.DELETE);
	final boolean sharePermission = agent.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = agent.hasPermission(Permission.SET_OWNER);
	final boolean isOwner = agent.isOwner();
	final boolean isRemoved = agent.isRemoved();
	final boolean isUsed = isRemoved && agent.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, agent);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page title="<%=title%>">
	<base:head scripts="tabcontrol.js,table.js" styles="toolbar.css,headertabcontrol.css,path.css,table.css,progressbar.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareJobAgent', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			Main.listItems('<%=ID%>', '<%=itemType.name()%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function configurePlugin(pluginId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true, '&plugin_id='+pluginId);
		}
		function controlJobAgent(cmd)
		{
			location.href = 'index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>';
		}
		</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Job agents" href="<%="index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(agent.getName())%>" />
		</p:path>
		
		<t:tabcontrol id="main" active="properties">
		<t:tab id="properties" title="Properties">
		
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this job agent" : "You do not have permission to edit this job agent"%>" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!agent.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this job agent" : "You do not have permission to delete this job agent"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=agent.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this job agent" : "You do not have permission to restore this job agent"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this job agent to other user, groups and projects" : "You do not have permission to share this job agent"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<tbl:button
				image="start.png"
				onclick="controlJobAgent('Start')"
				title="Start"
				tooltip="Start the job agent"
				visible="<%=writePermission && paused != null && paused == true%>"
			/>
			<tbl:button
				image="pause.png"
				onclick="controlJobAgent('Pause')"
				title="Pause"
				tooltip="Pause the job agent"
				visible="<%=writePermission && paused != null && paused == false%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'jobagent.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<%
			if (cc.getMessage() != null)
			{
				%>
				<div class="error"><%=cc.getMessage()%></div>
				<%
				cc.setMessage(null);
			}
			%>
		
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(agent)%></i></div>
			<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
				<base:icon image="shared.gif" 
					visible="<%=agent.isShared()%>"> This item is shared to other user, groups and/or projects</base:icon>
				<base:icon image="warning.gif"
					visible="<%=!agent.isShared()%>"> This item is NOT shared to other users, groups or projects. Only the
					owner will be able to run jobs on this agent</base:icon>
			</div>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><%=HTML.encodeTags(agent.getName())%></td>
			</tr>
			<tr>
				<td class="prompt">External ID</td>
				<td><%=HTML.encodeTags(agent.getExternalId())%></td>
			</tr>
			<tr>
				<td class="prompt">Server</td>
				<td><%=HTML.encodeTags(agent.getServer())%></td>
			</tr>
			<tr>
				<td class="prompt">Port</td>
				<td><%=agent.getPort() == null ? "" : agent.getPort().toString()%></td>
			</tr>
			<tr>
				<td class="prompt">Status</td>
				<td>
				<%=paused == null ? "<i>- unknown -</i>" : paused == true ? "Paused" : "Running"%>
				</td>
			</tr>
			<tr>
				<td class="prompt">CPU usage</td>
				<td><%=info.getCpuUsage() == null ? "<i>- unknown -</i>" : info.getCpuUsage() + "%"%></td>
			</tr>
			<tr>
				<td class="prompt">Memory</td>
				<td>
					Total: <%=info.getTotalMemory() == null ? "<i>- unknown -</i>" : Values.formatBytes(info.getTotalMemory())%>,
					Used: <%=info.getUsedMemory() == null ? "<i>- unknown -</i>" : Values.formatBytes(info.getUsedMemory())%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=agent%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(agent.getDescription())%></td>
			</tr>
			</table>
			
			
			<%
			ItemQuery<JobAgentSettings> query = agent.getSettings();
			query.include(Include.ALL);
			query.order(Orders.asc(Hql.property("pluginDefinition.name")));
			ItemResultList<JobAgentSettings> plugins = query.list(dc);
			
			if (plugins.size() == 0)
			{
				%>
				<h4>Installed plugins</h4>
				This job agent has no installed plugins (or, you don't have permission to view them).
				<%
			}
			else
			{
				%>
				<base:section
					id="plugins"
					title="<%="Plugins (" + plugins.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="plugins"
						clazz="itemlist"
						columns="all"
						>
					<tbl:columndef 
						id="plugin"
						title="Plugin"
					/>
					<tbl:columndef 
						id="jarPath"
						title="JAR path"
					/>
					<tbl:columndef 
						id="trusted"
						title="Trusted"
					/>
					<tbl:columndef 
						id="maxMemory"
						title="Max memory"
					/>
					<tbl:columndef 
						id="priorityBoost"
						title="Priority boost"
					/>
					<tbl:columndef
						id="configure"
						title=""
					/>
					<tbl:data>
						<tbl:columns>
						</tbl:columns>
						<tbl:rows>
						<%
						for (JobAgentSettings settings : plugins)
						{
							PluginDefinition plugin = null;
							NameablePluginAdaptor nameableProxy = null;
							boolean readPlugin = true;
							try
							{
								plugin = settings.getPluginDefinition();
								nameableProxy = new NameablePluginAdaptor(plugin);
							}
							catch (PermissionDeniedException ex)
							{
								readPlugin = false;
							}
							Long maxMemory = settings.getEffectiveMaxMemory();
							String jarPath = settings.getEffectiveJarPath();
							%>
							<tbl:row>
								<tbl:cell column="plugin"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=plugin != null && plugin.isRemoved()%>"
									/><%=Base.getLinkedName(ID, nameableProxy, !readPlugin, true)%></tbl:cell>
								<tbl:cell column="jarPath"><%=jarPath == null ? "<i>- internal -</i>" : HTML.encodeTags(jarPath)%></tbl:cell>
								<tbl:cell column="trusted"><%=settings.isEffectivelyTrusted()%></tbl:cell>
								<tbl:cell column="maxMemory"><%=maxMemory == null ? "<i>- not specified -</i>" : Values.formatBytes(maxMemory)%></tbl:cell>
								<tbl:cell column="priorityBoost"><%=settings.getPriorityBoost()%></tbl:cell>
								<tbl:cell column="configure">
								<%
								if (writePermission && plugin != null)
								{
									%>
									<base:icon image="runplugin.gif" 
										onclick="<%="configurePlugin(" + plugin.getId() + ")"%>"
										tooltip="Configure the settings for this plugin on the job agent "/>
									<%
								}
								%>
								</tbl:cell>
							</tbl:row>
							<%
						}
						%>
						</tbl:rows>
					</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			%>

			<%
			Set<JobInfo> jobs = agent.getInfo().getJobInfo();
			if (jobs == null || jobs.size() == 0)
			{
				%>
				<h4>Executing jobs</h4>
				<%
				if (jobs == null)
				{
					%>
					Unknown
					<%
				}
				else
				{
					%>
					No jobs are currently executing on this job agent
					<%
				}
			}
			else
			{
				%>
				<base:section
					id="executingJobs"
					title="<%="Executing jobs (" + jobs.size() + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table
						id="jobs"
						clazz="itemlist"
						columns="all"
						>
						<tbl:columndef 
							id="job"
							title="Job"
						/>
						<tbl:columndef 
							id="plugin"
							title="Plugin"
						/>
						<tbl:columndef 
							id="slot"
							title="Used slot"
						/>
						<tbl:columndef 
							id="started"
							title="Started"
						/>
						<tbl:columndef 
							id="percentComplete"
							title="Percent complete"
						/>
						<tbl:columndef 
							id="owner"
							title="Owner"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							for (JobInfo jobInfo : jobs)
							{
								Job job = null;
								boolean readJob = true;
								try
								{
									job = Job.getById(dc, jobInfo.getJobId());
								}
								catch (Throwable t)
								{
									readJob = false;
								}
								%>
								<tbl:row>
									<tbl:cell column="job"><%=Base.getLinkedName(ID, job, !readJob, true) %></tbl:cell>
									<tbl:cell column="plugin"><base:propertyvalue item="<%=job%>" property="pluginDefinition"/></tbl:cell>
									<tbl:cell column="started"><%=job == null ? "" : dateFormatter.format(job.getStarted())%></tbl:cell>
									<tbl:cell column="slot"><%=jobInfo.getSlot() == null ? "" : jobInfo.getSlot().toString()%></tbl:cell>
									<tbl:cell column="percentComplete">
										<%
										if (job != null)
										{
											%>
											<table border=0 cellspacing=0 cellpadding=0>
											<tr>
											<td width="100">
												<table width="100" class="progressbar" border=0 cellspacing=0 cellpadding=0>
												<tr>
													<%
													int percent = job.getPercentComplete();
													if (percent > 0) 
													{
														%>
														<td width="<%=percent%>%" class="done">&nbsp;</td>
														<% 
													}
													if (percent == -1)
													{
														%>
														<td width="100%" class="unknown">unknown</td>
														<%
													}
													else if (percent < 100) 
													{
														%>
														<td width="<%=100-percent%>%" class="remain">&nbsp;</td>
														<%
													}
													%>
												</tr>
												</table>								
											</td>
											<%if (percent != -1) { %>
											<td>&nbsp;<%=percent%>%</td>
											<%} %>
											</tr>
											</table>
											<%
										}
										%>
									</tbl:cell>
									<tbl:cell column="owner"><base:propertyvalue item="<%=job%>" property="owner" /></tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			%>
			<jsp:include page="../../common/anytoany/list_anytoany.jsp">
				<jsp:param name="ID" value="<%=ID%>" />
				<jsp:param name="item_type" value="<%=itemType.name()%>" />
				<jsp:param name="item_id" value="<%=itemId%>" />
				<jsp:param name="title" value="Other items related to this job agent" />
			</jsp:include>
			<%
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(agent));
			List<User> users = mp.getUsers().list(dc);
			List<Group> groups = mp.getGroups().list(dc);
			List<Project> projects = mp.getProjects().list(dc);
			int totalShare = users.size() + groups.size() + projects.size();
			
			if (totalShare > 0)
			{
				%>
				<base:section
					id="sharedTo"
					title="<%="Shared to (" + totalShare + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table 
						id="itemsSharedTo"
						clazz="itemlist"
						columns="all"
					>
						<tbl:columndef 
							id="itemType"
							title="Item type"
						/>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="permissions"
							title="Permissions"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							for (Project project : projects)
							{								
								Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
								%>			
								<tbl:row>
									<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=project.isRemoved()%>"
									/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							for (Group group : groups)
							{
								Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=group.isRemoved()%>"
									/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%	
							}
							for (User user : users)
							{
								Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This job agent is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}			
			%>			
			
		</div>
		</t:tab>
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
