<%-- $Id: ajax.jsp 5557 2011-01-28 11:48:15Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2010 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false" contentType="application/json"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioWell"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.error.ThrowableUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.WebException"
	import="org.json.simple.JSONObject"
	import="org.json.simple.JSONArray"
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final String cmd = request.getParameter("cmd");
final String root = request.getContextPath()+"/";
final int itemId = Values.getInt(request.getParameter("item_id"));
DbControl dc = null;
out.clear();
JSONObject json = new JSONObject();
json.put("status", "ok");
try
{
	if ("GetFullPlateInfo".equals(cmd))
	{
		boolean countChildren = Values.getBoolean(request.getParameter("countChildren"));
		boolean countPooled = countChildren && "pooled".equals(request.getParameter("countChildren"));
		dc = sc.newDbControl();
		
		BioPlate plate = BioPlate.getById(dc, itemId);
		PlateGeometry geometry = plate.getPlateGeometry();
		
		json.put("id", plate.getId());
		json.put("name", plate.getName());
		json.put("barcode", plate.getBarcode());
		json.put("rows", geometry.getRows());
		json.put("columns", geometry.getColumns());
		
		JSONArray jsonWells = new JSONArray();
		for (BioWell well : plate.getBioWells().list(dc))
		{
			JSONObject jsonWell = new JSONObject();
			jsonWell.put("id", well.getId());
			jsonWell.put("row", well.getRow());
			jsonWell.put("column", well.getColumn());
			jsonWell.put("canAdd", well.canAddBioMaterial());
			jsonWell.put("canClear", well.canClearBioMaterial());
			jsonWell.put("isEmpty", well.isEmpty());
			if (!well.isEmpty())
			{
				JSONObject jsonBioMaterial = new JSONObject();
				MeasuredBioMaterial bm = well.getBioMaterial();
				jsonBioMaterial.put("id", bm.getId());
				jsonBioMaterial.put("type", bm.getType().name());
				jsonBioMaterial.put("name", bm.getName());
				if (countChildren)
				{
					jsonBioMaterial.put("childCount", bm.countChildren(countPooled));
				}
				jsonWell.put("bioMaterial", jsonBioMaterial);
			}
			jsonWells.add(jsonWell);
		}
		json.put("wells", jsonWells);
		dc.close();
	}
	else
	{
		throw new WebException("popup", "Invalid command", "The command {1} is not recognised as a valid command.", cmd);
	}
}
catch (Throwable t)
{
	t.printStackTrace();
	json.clear();
	json.put("status", "error");
	json.put("message", t.getMessage());
	json.put("stacktrace", ThrowableUtil.stackTraceToString(t));
}
finally
{
	json.writeJSONString(out);
	out.flush();
	if (dc != null) dc.close();
}
%>