<%-- $Id: edit_directory.jsp 5501 2010-11-18 11:05:43Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Directory"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.DIRECTORY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	Directory directory = null;
	Directory parent = null;
	boolean autoCompress = false;
	boolean autoShare = false;

	if (itemId == 0)
	{
		title = "Create directory";
		parent = Directory.getById(dc, Values.getInt(request.getParameter("parent_id"), 
			SystemItems.getId(Directory.ROOT))
		);
		autoCompress = parent.getAutoCompress();
		autoShare = parent.getAutoShare();
		cc.removeObject("item");
	}
	else
	{
		directory = Directory.getById(dc, itemId);
		parent = directory.getParent();
		autoCompress = directory.getAutoCompress();
		autoShare = directory.getAutoShare();
		cc.setObject("item", directory);
		title = "Edit directory -- " + HTML.encodeTags(directory.getName());
	}
	if (directory != null && !directory.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}

	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), directory);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "Directory" tab
		function validateDirectory()
		{
			var frm = document.forms['directory'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			return true;
		}
		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['directory'];
			if (TabControl.validateActiveTab('settings'))
			{
				frm.submit();
			}
		}
		
		function init()
		{
			<%
			if (directory == null)
			{
				%>
				var frm = document.forms['directory'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="directory" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">
		<input type="hidden" name="parent_id" value="<%=parent.getId()%>">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*240)+"px;"%>" 
			position="bottom" remember="<%=directory != null%>"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Directory" validate="validateDirectory()" helpid="directory.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Path</td>
				<td><%=HTML.encodeTags(parent.getPath().toString())%></td>
			</tr>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(directory == null ? Values.getString(cc.getPropertyValue("name"), "New directory") : directory.getName())%>" 
					size="40" maxlength="<%=Directory.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Compress new files</td>
				<td>
					<input type="radio" name="autoCompress" value="0" <%=!autoCompress ? "checked" : ""%>>no
					<input type="radio" name="autoCompress" value="1" <%=autoCompress ? "checked" : ""%>>yes
					<input type="checkbox" name="autoCompressRecursive" value="1"
						title="Select this checkbox to set this property on all subdirectories">Recursive
				</td>
			</tr>	
			<tr>
				<td class="prompt">
					Share new files and sub-<br>
					directories automatically
				</td>
				<td>
					<input type="radio" name="autoShare" value="0" <%=!autoShare ? "checked" : ""%>>no
					<input type="radio" name="autoShare" value="1" <%=autoShare ? "checked" : ""%>>yes
					<input type="checkbox" name="autoShareRecursive" value="1"
						title="Select this checkbox to set this property on all subdirectories">Recursive
				</td>
			</tr>	
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(directory == null ? cc.getPropertyValue("description") : directory.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'directory', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>

		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
