<%-- $Id: main.jsp 5479 2010-11-08 07:33:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This is the front page of BASE. It displays a login form
	and some of the relevant news items.

	@param login The value to display in the login input field.
	@param error An error message that should be displayed

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.servlet.RssNewsFeed"
	import="net.sf.basedb.util.Values"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final String login = Values.getString(request.getParameter("login"), "");
final String error = Values.getString(request.getParameter("error"), null);
final String root = request.getContextPath()+"/";

final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
final DbControl dc = sc.newDbControl();
String broadcastTitle = (String)application.getAttribute("broadcast.title");
String broadcastMessage = (String)application.getAttribute("broadcast.message");
boolean denyLogin = Boolean.TRUE.equals(application.getAttribute("broadcast.deny-login"));
ItemResultList<News> news = null;
try
{
	%>
	<base:page type="default" title="">
	<base:head scripts="md5.js" styles="login.css">
		<script language="JavaScript" type="text/javascript">
		// Set foucs on the login form
		function init()
		{
			setFocus();
			top.frames['footnote'].location.reload();
		}
		
		// Set the focus on either the login or password field.
		function setFocus()
		{
			frm = document.forms['login'];
			if (frm.login.value == '' && window.parent.lastLogin) frm.login.value = window.parent.lastLogin;
			if (frm.encrypt && window.parent.encrypt != undefined) frm.encrypt.checked = window.parent.encrypt;
			if (frm.login.value == '')
			{
				frm.login.focus();
			}
			else
			{
				frm.password.focus();
				frm.password.select();
			}
		}
		function saveLogin()
		{
			var frm = document.forms['login'];
			window.parent.lastLogin = frm.login.value;
			
			if (frm.encrypt)
			{
				window.parent.encrypt = frm.encrypt.checked;
				if (frm.encrypt.checked)
				{
					var password = frm.password.value;
					var md5password = hex_md5(password);
					md5password = hex_md5(md5password + ':<%=sc.getChallenge()%>');
					frm.encrypted_password.value = md5password;
					frm.password.value = '';
				}
			}
			return true;
		}
		function doLogin()
		{
			var denyLogin = <%=denyLogin ? "true" : "false"%>;
			if (denyLogin && !confirm('Login has been disabled by an administrator. Do you want to continue anyway?'))
			{
				return false;
			}
			saveLogin();
			var frm = document.forms['login'];
			frm.submit();
		}
		function showLoginForm()
		{
			Main.show('loginForm');
			Main.hide('denyLogin');
		}
		</script>
	</base:head>
	
	<base:body onload="init();">
	
		<table border=0 cellspacing=5 cellpadding=0 width="80%" align="center">
		<tr>
		<td>
			<br><br>
			<table class="loginform" width="100%" border="0" align="center">
			<%
			if (error != null) 
			{
				%>
				<tr><td colspan="2" align="center"><div class="error"><%=error%></div></td></tr>
				<%
			}
			%>
			<tr>
				<td style="vertical-align: middle; width; 25%;">
					<div align="center">
						<img src="images/baselogo.png" alt="BASE logo" width=122 height=58>
					</div>
				</td>
				<td style="width: 75%;">
					<form name="login" action="login.jsp" method="post" onsubmit="doLogin();">
					<input type="hidden" name="ID" value="<%=ID%>">
					<input type="hidden" name="nextpage" value="<%=root%>my_base/user/index.jsp">
					<input type="hidden" name="encrypted_password" value="">
					
					<div id="loginForm" <%=denyLogin ? "style=\"display:none;\"" : ""%>>
					<table border="0" cellspacing="0" cellpadding="2">
					<tr>
						<td class="prompt">Login</td>
						<td><input class="text" type="text" name="login" value="<%=HTML.encodeTags(login)%>" 
							size="15" maxlength="100"
							style="width: 120px"></td>
					</tr>
					<tr>
						<td class="prompt">Password</td>
						<td>
							<input class="text" type="password" name="password" size="15" maxlength="80"
								onkeypress="return Forms.submitOnEnter(event, doLogin)"
								style="width: 120px">
						</td>
						<td><base:button image="login.png" 
							onclick="doLogin();" title="Login" tooltip="<%=HTML.encodeTags(broadcastTitle)%>" /></td>
					</tr>
					<%
					if (Application.isUsingInternalAuthentication())
					{
						%>
						<tr>
							<td class="prompt">Encrypt password</td>
							<td>
								<input type="checkbox" name="encrypt" <%=false ? "" : "checked"%> value="1"><br>
							</td>
						</tr>
						<%
					}
					%>
					<tr>
						<td colspan="3">
						<%
						String forgotPassword = sc.getClientDefaultSetting("server.forgotten.password");
						String getAccount = sc.getClientDefaultSetting("server.get.account");
						if (forgotPassword != null)
						{
							%>
							<base:icon image="bullet.gif" />
							<a href="javascript:Main.openPopup('info/forgot_password.jsp?ID=<%=ID%>', 'ForgotPassword', 500, 300)" title="Click here if you have forgotten your password">Forgot your password?</a>
							<%
						}
						if (getAccount != null)
						{
							%>
							<base:icon image="bullet.gif" />
							<a href="javascript:Main.openPopup('info/get_account.jsp?ID=<%=ID%>', 'GetAccount', 500, 300)" title="Click here if you want to get an account on this server">Get an account!</a>
							<%
						}
						%>
						</td>
					</tr>
					</table>
					</div>
					<div id="denyLogin" <%=denyLogin ? "style=\"width: 90%; margin-left: 5%;\"" : "style=\"display:none;\""%> class="news">
						<div class="item">
						<span class="headline"><%=HTML.encodeTags(broadcastTitle) %> (login disabled)</span><br>
						<span class="text"><%=HTML.niceFormat(broadcastMessage)%></span>
						</div>
						<table>
							<tr><td><base:button title="Login anyway" onclick="showLoginForm()" 
								image="login.png" tooltip="At your own risk!"/></td></tr>
						</table>
					</div>
					</form>
				</td>
			</tr>
			</table>
			<br>
			<br>
			
			<%
			String aboutServer = sc.getClientDefaultSetting("server.about");
			if (aboutServer != null)
			{
				%>
				<h3>About this server</h3>
				<p>
					<%=aboutServer%>
				</p>
				<base:icon image="bullet.gif" />
				<a href="javascript:Main.openPopup('info/about.jsp?ID=<%=ID%>&page=about', 'About', 500, 350)">More about this server</a>
				<%
			}
			%>
			
			<h3>News and announcements 
			<%
			if (RssNewsFeed.isEnabled()) 
			{
				%>
				<a href="info/news.rss" 
					title="Subscribe to news from this BASE server"
					><base:icon image="rss.png" /></a>
				<%
			}
			%>
			</h3>
			<div id="news" class="news">
			<%
			if (broadcastTitle != null)
			{
				%>
				<div class="item"><base:icon image="warning.gif" />
					<span class="date"><%=dateFormatter.format(new Date())%></span>
					<span class="headline"><%=HTML.encodeTags(broadcastTitle)%><%=denyLogin ? " (login disabled)" : "" %></span><br>
					<span class="text"><%=HTML.niceFormat(broadcastMessage)%></span>
				</div>
				<% 
			}
			
			ItemQuery<News> query = News.getQuery();
			query.order(Orders.desc(Hql.property("newsDate")));
			query.order(Orders.desc(Hql.property("id")));
			query.setCacheResult(true);
			query.setReturnTotalCount(true);
			query.setMaxResults(10);
			news = query.list(dc);
			for (News n : news)
			{
				%>
				<div class="item">
					<span class="date"><%=dateFormatter.format(n.getNewsDate())%></span>
					<span class="headline"><%=HTML.encodeTags(n.getName())%></span><br>
					<span class="text"><%=HTML.niceFormat(n.getDescription())%></span>
				</div>
				<%
			}
			if (news.getTotalCount() > 10)
			{
				%>
				<base:icon image="bullet.gif" /><a href="info/news.jsp" 
					title="Show older news..."><%=news.getTotalCount()-10%> more</a>
				<%
			}
			%>
			</div>
		</td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

