<%-- $Id: edit_rawbioassay.jsp 5574 2011-02-18 12:19:38Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.Platform"
	import="net.sf.basedb.core.PlatformVariant"
	import="net.sf.basedb.core.Scan"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.ProtocolType"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.Software"
	import="net.sf.basedb.core.SoftwareType"
	import="net.sf.basedb.core.ArrayDesign"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawDataTypes"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.RAWBIOASSAY;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String tabId = Values.getString(request.getParameter("tab"), null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	RawBioAssay rawBioAssay = null;
	String name = null;
	boolean hasDbSpots = false;

	boolean deniedPlatform = false;
	Platform currentPlatform = null;
	Platform defaultPlatform = null;
	PlatformVariant currentVariant = null;
	PlatformVariant defaultVariant = null;
	
	boolean readCurrentScan = true;
	Scan currentScan = null;
	boolean readCurrentProtocol = true;
	Protocol currentProtocol = null;
	Protocol defaultProtocol = null;
	boolean readCurrentSoftware = true;
	Software currentSoftware = null;
	Software defaultSoftware = null;
	boolean readCurrentArrayDesign = true;
	ArrayDesign currentArrayDesign = null;
	ArrayDesign defaultArrayDesign = null;
	RawDataType currentRawDataType = null;
	RawDataType defaultRawDataType = null;

	// Load recently used items
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL);
	List<Scan> recentScans = (List<Scan>)cc.getRecent(dc, Item.SCAN);
	List<Software> recentSoftware = (List<Software>)cc.getRecent(dc, Item.SOFTWARE);
	List<ArrayDesign> recentArrayDesigns = (List<ArrayDesign>)cc.getRecent(dc, Item.ARRAYDESIGN);
	List<File> recentFiles = (List<File>)cc.getRecent(dc, Item.FILE);
	
	int activeProjectId = sc.getActiveProjectId();
	if (activeProjectId > 0)
	{
		Project activeProject = Project.getById(dc, activeProjectId);
		try
		{
			defaultProtocol = (Protocol)activeProject.getDefaultItem(dc, Project.Default.FEATURE_EXTRACTION_PROTOCOL);			
		}
		catch (PermissionDeniedException pdex)
		{
			defaultProtocol = null;
		}
		try
		{
			defaultSoftware = (Software)activeProject.getDefaultItem(dc, Project.Default.SOFTWARE);			
		}
		catch (PermissionDeniedException pdex)
		{
			defaultSoftware = null;
		}
		try
		{
			defaultArrayDesign = (ArrayDesign)activeProject.getDefaultItem(dc, Project.Default.ARRAYDESIGN);			
		}
		catch (PermissionDeniedException pdex)
		{
			defaultArrayDesign = null;
		}
		try
		{
			defaultPlatform = (Platform)activeProject.getDefaultItem(dc, Project.Default.PLATFORM);
		}
		catch (PermissionDeniedException pdex)
		{}
		try
		{
			defaultVariant = (PlatformVariant)activeProject.getDefaultItem(dc, Project.Default.PLATFORM_VARIANT);
		}
		catch (PermissionDeniedException pdex)
		{}
		defaultRawDataType = activeProject.getDefaultRawDataType();
	}
	if (itemId == 0)
	{
		title = "Create raw bioassay";
		cc.removeObject("item");
		
		int currentPlatformId = Values.getInt(cc.getPropertyValue("platform"), 0);
		if (currentPlatformId == 0)
		{
			currentPlatformId = Values.getInt(cc.getRecent(Item.PLATFORM.name(), 0), 0);
		}
		int currentVariantId = Values.getInt(cc.getRecent(Item.PLATFORMVARIANT.name(), 0), 0);
		
		try
		{
			if (currentVariantId != 0) currentVariant = PlatformVariant.getById(dc, currentVariantId);
			if (currentPlatformId != 0) currentPlatform = Platform.getById(dc, currentPlatformId);
		}
		catch (Throwable t)
		{}
		if (currentPlatform == null) currentPlatform = defaultPlatform;
		if (currentVariant == null) currentVariant = defaultVariant;
		
		currentRawDataType = RawDataTypes.getRawDataType(cc.getPropertyValue("rawDataType"));
		if (currentRawDataType == null)
		{
			currentRawDataType = RawDataTypes.getRawDataType(cc.getRecent("RawDataType", 0));
		}
		if (currentRawDataType == null) currentRawDataType = defaultRawDataType;

		int scanId = Values.getInt(request.getParameter("scan_id"));
		if (scanId != 0)
		{
			currentScan = Scan.getById(dc, scanId);
		}
		else if (cc.getPropertyFilter("scan.name") != null)
		{
			currentScan = Base.getFirstMatching(dc, Scan.getQuery(), "name", cc.getPropertyFilter("scan.name"));
		}

		if (currentScan != null)
		{
			name = currentScan.getName() + ".r" + (currentScan.countRawBioAssays() + 1);
		}
		else
		{
			name = Values.getString(cc.getPropertyValue("name"), "New raw bioassay");
		}
		if (cc.getPropertyFilter("protocol.name") != null)
		{
			currentProtocol = Base.getFirstMatching(dc, Protocol.getQuery(), "name", cc.getPropertyFilter("protocol.name"));
		}
		
		if (cc.getPropertyFilter("software.name") != null)
		{
			currentSoftware = Base.getFirstMatching(dc, Software.getQuery(), "name", cc.getPropertyFilter("software.name"));
		}
		if (currentScan != null)
		{
			try
			{
				currentArrayDesign = currentScan.getArrayDesign();
			}
			catch (PermissionDeniedException ex)
			{}
		}
		if (currentArrayDesign == null && cc.getPropertyFilter("arrayDesign.name") != null)
		{
			currentArrayDesign = Base.getFirstMatching(dc, ArrayDesign.getQuery(), "name", cc.getPropertyFilter("arrayDesign.name"));
		}
	}
	else
	{
		rawBioAssay = RawBioAssay.getById(dc, itemId);
		rawBioAssay.checkPermission(Permission.WRITE);
		hasDbSpots = rawBioAssay.getNumDbSpots() > 0;
		cc.setObject("item", rawBioAssay);
		name = rawBioAssay.getName();
		try
		{
			currentRawDataType = rawBioAssay.getRawDataType();
		}
		catch (Throwable t)
		{}
		title = "Edit raw bioassay -- " + HTML.encodeTags(rawBioAssay.getName());
		
		try
		{
			currentPlatform = rawBioAssay.getPlatform();
			currentVariant = rawBioAssay.getVariant();
		}
		catch (PermissionDeniedException ex)
		{
			deniedPlatform = true;
		}
		
		try
		{
			currentScan = rawBioAssay.getScan();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentScan = false;
		}
		try
		{
			currentProtocol = rawBioAssay.getProtocol();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentProtocol = false;
		}
		try
		{
			currentSoftware = rawBioAssay.getSoftware();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentSoftware = false;
		}
		try
		{
			currentArrayDesign = rawBioAssay.getArrayDesign();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentArrayDesign = false;
		}
	}
	
	ItemQuery<Platform> platformQuery = Platform.getQuery();
	platformQuery.include(Include.REMOVED, Include.NOT_REMOVED);
	platformQuery.order(Orders.asc(Hql.property("name")));
	platformQuery.setCacheResult(true);
	ItemResultList<Platform> platforms = platformQuery.list(dc);

	ItemQuery<PlatformVariant> variantQuery = PlatformVariant.getQuery();
	variantQuery.include(Include.REMOVED, Include.NOT_REMOVED);
	variantQuery.order(Orders.asc(Hql.property("name")));
	variantQuery.setCacheResult(true);
	ItemResultList<PlatformVariant> variants = variantQuery.list(dc);
	
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), rawBioAssay);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js,platforms.js,ajax.js,json2.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "RawBioAssay" tab
		function validateRawBioAssay()
		{
			var frm = document.forms['rawbioassay'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			else if (!Numbers.isInteger(frm.arrayNum.value))
			{
				alert("'" + frm.arrayNum.value + "' is not a valid number");
				frm.arrayNum.focus();
				return false;
			}
			else if (parseInt(frm.arrayNum.value) <= 0)
			{
				alert("Array index must be > 0");
				frm.arrayNum.focus();
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['rawbioassay'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				if (dataFilesLoaded)
				{
					Platforms.addDataFilesToForm(frames.datafiles, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		var protocolChanged = false;
		var dataFilesLoaded = false;
		var platformChanged = false;
		function switchTab(tabControlId, tabId)
		{
			var frm = document.forms['rawbioassay'];
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && (protocolChanged || !annotationsLoaded))
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=rawBioAssay == null ? 0 : rawBioAssay.getId()%>, getProtocolId());
					annotationsLoaded = true;
					protocolChanged = false;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
				else if (tabId == 'datafiles' && (platformChanged || !dataFilesLoaded))
				{
					var platform = Platforms.getSelectedPlatform(frm.platform);
					var variant = Platforms.getSelectedVariant(frm.platform);
					Platforms.loadDataFilesFrame(frames.datafiles, '<%=ID%>', '<%=itemType.name()%>', <%=rawBioAssay == null ? 0 : rawBioAssay.getId()%>, platform == null ? 0 : platform.id, variant == null ? 0 : variant.id);
					dataFilesLoaded = true;
					platformChanged = false;
				}
			}
		}

		function platformOnChange()
		{
			var frm = document.forms['rawbioassay'];
			platformChanged = true;
			var platform = Platforms.getSelectedPlatform(frm.platform);
			var variant = Platforms.getSelectedVariant(frm.platform);
			var fileOnly = (variant != null && variant.fileOnly) || 
				(variant == null && platform.fileOnly);
			var rawDataType = variant == null ? platform.rawDataType : variant.rawDataType;
			if (frm.rawdatatype[frm.rawdatatype.length - 1].value == '')
			{
				frm.rawdatatype[frm.rawdatatype.length - 1] = null;
			}
			if (fileOnly)
			{
				frm.rawdatatype.disabled = true;
				Main.removeClass(frm.rawdatatype, 'required');
				frm.rawdatatype[frm.rawdatatype.length] = new Option('- file only -', '');
				frm.rawdatatype.selectedIndex = frm.rawdatatype.length - 1;
			}
			else if (rawDataType)
			{
				frm.rawdatatype.disabled = true;
				Main.removeClass(frm.rawdatatype, 'required');
				Forms.selectListOption(frm.rawdatatype, rawDataType);
			}
			else
			{
				frm.rawdatatype.disabled = <%=hasDbSpots ? "true" : "false"%>;
				Main.addClass(frm.rawdatatype, 'required');
			}
		}

		function getProtocolId()
		{
			var frm = document.forms['rawbioassay'];
			var protocolId = 0;
			if (frm.protocol_id.length > 0 && !frm.protocol_id.disabled) 
			{
				protocolId = Math.abs(parseInt(frm.protocol_id[frm.protocol_id.selectedIndex].value));				
			}
			return protocolId;
		}

		function getParents()
		{
			var frm = document.forms['rawbioassay'];
			var parents = new Array();

			var scanId = Math.abs(parseInt(frm.scan_id[frm.scan_id.selectedIndex].value));
			if (scanId > 0) parents[parents.length] = 'SCAN:'+scanId;
			if (frm.arraydesign_id)
			{
				var arrayDesignId = Math.abs(parseInt(frm.arraydesign_id[frm.arraydesign_id.selectedIndex].value));
				if (arrayDesignId > 0) parents[parents.length] = 'ARRAYDESIGN:'+arrayDesignId;
			}
			return parents;
		}

		function selectProtocolOnClick()
		{
			var frm = document.forms['rawbioassay'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:protocolType=<%=SystemItems.getId(ProtocolType.FEATURE_EXTRACTION)%>';
			Main.openPopup(url, 'SelectProtocol', 1000, 700);
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['rawbioassay'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			protocolChanged = true;
		}
		function protocolOnChange()
		{
			protocolChanged = true;
		}
		
		function scanOnChange()
		{
			var frm = document.forms['rawbioassay'];
			var selectedIndex = frm.scan_id.selectedIndex
			var scanId = frm.scan_id[selectedIndex].value;
			if (scanId > 0) updateArrayDesign(scanId);
			parentsChanged = true;
		}
		function selectScanOnClick()
		{
			var frm = document.forms['rawbioassay'];
			var url = '../scans/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setScanCallback';
			if (frm.scan_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.scan_id[1].value));
				url += '&item_id='+id;
			}
			Main.openPopup(url, 'SelectScan', 1000, 700);
		}
		function setScanCallback(id, name)
		{
			var frm = document.forms['rawbioassay'];
			var list = frm.scan_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			updateArrayDesign(id)
			parentsChanged = true;
		}
		
		function selectSoftwareOnClick()
		{
			var frm = document.forms['rawbioassay'];
			var url = '../../admin/software/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setSoftwareCallback';
			if (frm.software_id.length > 1)
			{
				var id = Math.abs(parseInt(frm.software_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:softwareType=<%=SystemItems.getId(SoftwareType.FEATURE_EXTRACTION)%>';
			Main.openPopup(url, 'SelectSoftware', 1000, 700);
		}
		function setSoftwareCallback(id, name)
		{
			var frm = document.forms['rawbioassay'];
			var list = frm.software_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function arrayDesignOnChange()
		{
			parentsChanged = true;
			<%
			if (rawBioAssay != null && rawBioAssay.getNumDbSpots() > 0)
			{
				%>
				var frm = document.forms['rawbioassay'];
				var selectedId = frm.arraydesign_id[frm.arraydesign_id.selectedIndex].value;
				var showFiMethod = (selectedId > 0 && selectedId != <%=currentArrayDesign == null ? 0 : currentArrayDesign.getId()%>);
				if (showFiMethod)
				{
					Main.show('fiMethod');
				}
				else
				{
					Main.hide('fiMethod');
				}
				<%
			}
			%>
		}
		function selectArrayDesignOnClick()
		{
			var frm = document.forms['rawbioassay'];
			var url = '../../lims/arraydesigns/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setArrayDesignCallback';
			if (frm.arraydesign_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.arraydesign_id[1].value));				
				url += '&item_id='+id;
			}
			var platform = Platforms.getSelectedPlatform(frm.platform);
			url += '&resetTemporary=1&tmpfilter:INT:platform='+platform.id;
			Main.openPopup(url, 'SelectArrayDesign', 1000, 700);
		}
		function setArrayDesignCallback(id, name)
		{
			var frm = document.forms['rawbioassay'];
			var list = frm.arraydesign_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
			parentsChanged = true;
			arrayDesignOnChange();
		}
		function updateArrayDesign(scanId)
		{
			var request = Ajax.getXmlHttpRequest();
			if (request != null)
			{
				var url = '../scans/ajax.jsp?ID=<%=ID%>&cmd=GetArrayDesign&item_id=' + scanId;
				request.open("GET", url, true);
				Ajax.setReadyStateHandler(request, updateArrayDesignCallback);
				request.send(null);
			}
			return request != null;
		}
		function updateArrayDesignCallback(request)
		{
			var frm = document.forms['rawbioassay'];
			var response = Ajax.parseJsonResponse(request.responseText);
			if (response.status != 'ok')
			{
				alert(response.message);
				return false;
			}
			
			if (response.id)
			{
				var designList = frm.arraydesign_id;
				if (designList.length < 2 || designList[1].value == '0') // >
				{
					Forms.addListOption(designList, 1, new Option());
				}
				designList[1].value = response.id;
				designList[1].text = response.name;
				designList.selectedIndex = 1;
			}
		}
		
		function init()
		{
			<%
			if (rawBioAssay == null)
			{
				%>
				var frm = document.forms['rawbioassay'];
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
			initPlatforms(<%=currentPlatform == null ? 0 : currentPlatform.getId()%>, <%=currentVariant == null ? 0 : currentVariant.getId()%>);
			platformOnChange();
		}
		
		function initPlatforms(platformId, variantId)
		{
			<%
			for (Platform p : platforms)
			{
				if (!p.isRemoved() || p.equals(currentPlatform))
				{
					RawDataType rdt = p.isFileOnly() ? null : p.getRawDataType();
					%>
					var p<%=p.getId()%> = new Platform(<%=p.getId()%>, '<%=HTML.javaScriptEncode(p.getExternalId())%>', '<%=HTML.javaScriptEncode(p.getName())%>', <%=p.isFileOnly()%>, '<%=rdt == null ? "" : rdt.getId()%>');
					<%
				}
			}
			for (PlatformVariant v : variants)
			{
				Platform p = v.getPlatform();
				if ((!v.isRemoved() || v.equals(currentVariant)) && (!p.isRemoved() || p.equals(currentPlatform)))
				{
					RawDataType rdt = v.isFileOnly() ? null : v.getRawDataType();
					%>
					var v<%=v.getId()%> = new Variant(p<%=p.getId()%>, <%=v.getId()%>, '<%=HTML.javaScriptEncode(v.getExternalId())%>', '<%=HTML.javaScriptEncode(v.getName())%>', <%=v.isFileOnly()%>, '<%=rdt == null ? "" : rdt.getId()%>');
					<%
				}
			}
			%>
			var frm = document.forms['rawbioassay'];
			Platforms.populateList(frm.platform, platformId, variantId);
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="rawbioassay" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom" active="<%=tabId%>" remember="<%=tabId == null && rawBioAssay != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Raw bioassay" validate="validateRawBioAssay()" helpid="rawbioassay.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(name)%>" 
					size="40" maxlength="<%=RawBioAssay.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Array index</td>
				<td><input <%=requiredClazz%> type="text" name="arrayNum" 
					value="<%=rawBioAssay == null ? Values.getString(cc.getPropertyValue("arrayNum"), "1") : rawBioAssay.getArrayNum()%>" 
					size="12" maxlength="10" onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr>
				<td class="prompt">Platform</td>
				<td>
					<select name="platform" onchange="platformOnChange()" class="required"
						<%=deniedPlatform || hasDbSpots ? "disabled" : "" %>>
					<%
					if (deniedPlatform)
					{
						%>
						<option value="-1">- denied -
						<%
					}
					%>
					</select>
				</td>
			</tr>
			<tr>
				<td class="prompt">Raw data type</td>
				<td>
					<select name="rawdatatype" class="required"
						<%=hasDbSpots ? "disabled" : "" %>>
					<%
					for (RawDataType rdt : RawDataTypes.getSortedRawDataTypes(new RawDataTypes.NameComparator()))
					{
						if (rdt.isStoredInDb())
						{
							String selected = rdt.equals(currentRawDataType) ? "selected" : "";
							%>
							<option value="<%=rdt.getId()%>" <%=selected%>><%=HTML.encodeTags(rdt.getName())%>
							<%
						}
					}
					%>
					</select>
				</td>
			</tr>
			
			<tr>
				<td class="prompt">Array design</td>
				<td>
					<base:select 
						id="arraydesign_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentArrayDesign%>"
						denied="<%=!readCurrentArrayDesign%>"
						recent="<%=recentArrayDesigns%>"
						defaultitem="<%=defaultArrayDesign%>"
						newitem="<%=rawBioAssay == null%>"
						onselect="selectArrayDesignOnClick()"
						onchange="arrayDesignOnChange()"
					/>
				</td>
			</tr>
			<tr id="fiMethod" style="display: none;">
				<td></td>
				<td>
				<select name="fiMethod">
				<option value="">-auto- (array design decides)
				<option value="COORDINATES">Coordinates
				<option value="POSITION">Position
				<option value="FEATURE_ID">Feature ID (*)
				</select>
				<br>
				Select a method for feature identification. <br>
				(*) The Feature ID method only works if the raw data is currently
				connected to an array design which has Feature ID values.
				</td>
			</tr>
			<tr>
				<td class="prompt">Protocol</td>
				<td>
					<base:select 
						id="protocol_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentProtocol%>"
						denied="<%=!readCurrentProtocol%>"
						recent="<%=recentProtocols%>"
						defaultitem="<%=defaultProtocol%>"
						newitem="<%=rawBioAssay == null%>"
						onselect="selectProtocolOnClick()"
						onchange="protocolOnChange()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Scan</td>
				<td>
					<base:select 
						id="scan_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentScan%>"
						denied="<%=!readCurrentScan%>"
						recent="<%=recentScans%>"
						newitem="<%=rawBioAssay == null%>"
						onselect="selectScanOnClick()"
						onchange="scanOnChange()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Software</td>
				<td>
					<base:select 
						id="software_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentSoftware%>"
						denied="<%=!readCurrentSoftware%>"
						recent="<%=recentSoftware%>"
						defaultitem="<%=defaultSoftware%>"
						newitem="<%=rawBioAssay == null%>"
						onselect="selectSoftwareOnClick()"
					/>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(rawBioAssay == null ? cc.getPropertyValue("description") : rawBioAssay.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'rawbioassay', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="datafiles" title="Data files" helpid="datafiles.edit">
			<iframe name="datafiles" id="idDatafiles" src="../../common/datafiles/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>

		<t:tab id="annotations" title="Annotations &amp; parameters" 
			helpid="annotations.edit" tooltip="Enter values for annotations and protocol parameters">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
